1 # SPDX-License-Identifier: GPL-2.0+
10 # To see a list of typical targets execute "make help"
11 # More info can be located in ./README
12 # Comments in this file are targeted only to the developer, do not
13 # expect to learn how to build the kernel reading this file.
15 # Do not use make's built-in rules and variables
16 # (this increases performance and avoids hard-to-debug behaviour)
19 # Determine target architecture for the sandbox
20 include include/host_arch.h
21 ifeq ("", "$(CROSS_COMPILE)")
22 MK_ARCH="${shell uname -m}"
24 MK_ARCH="${shell echo $(CROSS_COMPILE) | sed -n 's/^\s*\([^\/]*\/\)*\([^-]*\)-\S*/\2/p'}"
27 ifeq ("x86_64", $(MK_ARCH))
28 export HOST_ARCH=$(HOST_ARCH_X86_64)
29 else ifneq (,$(findstring $(MK_ARCH), "i386" "i486" "i586" "i686"))
30 export HOST_ARCH=$(HOST_ARCH_X86)
31 else ifneq (,$(findstring $(MK_ARCH), "aarch64" "armv8l"))
32 export HOST_ARCH=$(HOST_ARCH_AARCH64)
33 else ifneq (,$(findstring $(MK_ARCH), "arm" "armv7" "armv7l"))
34 export HOST_ARCH=$(HOST_ARCH_ARM)
35 else ifeq ("riscv32", $(MK_ARCH))
36 export HOST_ARCH=$(HOST_ARCH_RISCV32)
37 else ifeq ("riscv64", $(MK_ARCH))
38 export HOST_ARCH=$(HOST_ARCH_RISCV64)
42 # Avoid funny character set dependencies
46 export LC_COLLATE LC_NUMERIC
48 # Avoid interference with shell env settings
51 # We are using a recursive build, so we need to do a little thinking
52 # to get the ordering right.
54 # Most importantly: sub-Makefiles should only ever modify files in
55 # their own directory. If in some directory we have a dependency on
56 # a file in another dir (which doesn't happen often, but it's often
57 # unavoidable when linking the built-in.o targets which finally
58 # turn into vmlinux), we will call a sub make in that other dir, and
59 # after that we are sure that everything which is in that other dir
62 # The only cases where we need to modify files which have global
63 # effects are thus separated out and done before the recursive
64 # descending is started. They are now explicitly listed as the
68 # ---------------------------------------------------------------------------
70 # Normally, we echo the whole command before executing it. By making
71 # that echo $($(quiet)$(cmd)), we now have the possibility to set
72 # $(quiet) to choose other forms of output instead, e.g.
74 # quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
75 # cmd_cc_o_c = $(CC) $(c_flags) -c -o $@ $<
77 # If $(quiet) is empty, the whole command will be printed.
78 # If it is set to "quiet_", only the short version will be printed.
79 # If it is set to "silent_", nothing will be printed at all, since
80 # the variable $(silent_cmd_cc_o_c) doesn't exist.
82 # A simple variant is to prefix commands with $(Q) - that's useful
83 # for commands that shall be hidden in non-verbose mode.
87 # If KBUILD_VERBOSE equals 0 then the above command will be hidden.
88 # If KBUILD_VERBOSE equals 1 then the above command is displayed.
90 # To put more focus on warnings, be less verbose as default
91 # Use 'make V=1' to see the full commands
93 ifeq ("$(origin V)", "command line")
100 ifeq ($(KBUILD_VERBOSE),1)
108 # If the user is running make -s (silent mode), suppress echoing of
111 ifneq ($(filter 4.%,$(MAKE_VERSION)),) # make-4
112 ifneq ($(filter %s ,$(firstword x$(MAKEFLAGS))),)
116 ifneq ($(filter s% -s%,$(MAKEFLAGS)),)
121 export quiet Q KBUILD_VERBOSE
123 # kbuild supports saving output files in a separate directory.
124 # To locate output files in a separate directory two syntaxes are supported.
125 # In both cases the working directory must be the root of the kernel src.
127 # Use "make O=dir/to/store/output/files/"
129 # 2) Set KBUILD_OUTPUT
130 # Set the environment variable KBUILD_OUTPUT to point to the directory
131 # where the output files shall be placed.
132 # export KBUILD_OUTPUT=dir/to/store/output/files/
135 # The O= assignment takes precedence over the KBUILD_OUTPUT environment
138 # KBUILD_SRC is set on invocation of make in OBJ directory
139 # KBUILD_SRC is not intended to be used by the regular user (for now)
140 ifeq ($(KBUILD_SRC),)
142 # OK, Make called in directory where kernel src resides
143 # Do we want to locate output files in a separate directory?
144 ifeq ("$(origin O)", "command line")
145 KBUILD_OUTPUT := $(O)
148 # That's our default target when none is given on the command line
152 # Cancel implicit rules on top Makefile
153 $(CURDIR)/Makefile Makefile: ;
155 ifneq ($(KBUILD_OUTPUT),)
156 # Invoke a second make in the output directory, passing relevant variables
157 # check that the output directory actually exists
158 saved-output := $(KBUILD_OUTPUT)
159 KBUILD_OUTPUT := $(shell mkdir -p $(KBUILD_OUTPUT) && cd $(KBUILD_OUTPUT) \
161 $(if $(KBUILD_OUTPUT),, \
162 $(error failed to create output directory "$(saved-output)"))
164 # Look for make include files relative to root of kernel src
166 # This does not become effective immediately because MAKEFLAGS is re-parsed
167 # once after the Makefile is read. It is OK since we are going to invoke
169 MAKEFLAGS += --include-dir=$(CURDIR)
171 PHONY += $(MAKECMDGOALS) sub-make
173 $(filter-out _all sub-make $(CURDIR)/Makefile, $(MAKECMDGOALS)) _all: sub-make
177 $(Q)$(MAKE) -C $(KBUILD_OUTPUT) KBUILD_SRC=$(CURDIR) \
178 -f $(CURDIR)/Makefile $(filter-out _all sub-make,$(MAKECMDGOALS))
180 # Leave processing to above invocation of make
182 endif # ifneq ($(KBUILD_OUTPUT),)
183 endif # ifeq ($(KBUILD_SRC),)
185 # We process the rest of the Makefile if this is the final invocation of make
186 ifeq ($(skip-makefile),)
188 # Do not print "Entering directory ...",
189 # but we want to display it when entering to the output directory
190 # so that IDEs/editors are able to understand relative filenames.
191 MAKEFLAGS += --no-print-directory
193 # Call a source code checker (by default, "sparse") as part of the
196 # Use 'make C=1' to enable checking of only re-compiled files.
197 # Use 'make C=2' to enable checking of *all* source files, regardless
198 # of whether they are re-compiled or not.
200 # See the file "doc/sparse.txt" for more details, including
201 # where to get the "sparse" utility.
203 ifeq ("$(origin C)", "command line")
204 KBUILD_CHECKSRC = $(C)
206 ifndef KBUILD_CHECKSRC
210 # Use make M=dir to specify directory of external module to build
211 # Old syntax make ... SUBDIRS=$PWD is still supported
212 # Setting the environment variable KBUILD_EXTMOD take precedence
214 KBUILD_EXTMOD ?= $(SUBDIRS)
217 ifeq ("$(origin M)", "command line")
218 KBUILD_EXTMOD := $(M)
221 # If building an external module we do not care about the all: rule
222 # but instead _all depend on modules
224 ifeq ($(KBUILD_EXTMOD),)
230 ifeq ($(KBUILD_SRC),)
231 # building in the source tree
234 ifeq ($(KBUILD_SRC)/,$(dir $(CURDIR)))
235 # building in a subdirectory of the source tree
238 srctree := $(KBUILD_SRC)
245 VPATH := $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))
247 export srctree objtree VPATH
249 # Make sure CDPATH settings don't interfere
252 #########################################################################
254 HOSTARCH := $(shell uname -m | \
256 -e s/sun4u/sparc64/ \
259 -e s/ppc64/powerpc/ \
261 -e s/macppc/powerpc/\
264 HOSTOS := $(shell uname -s | tr '[:upper:]' '[:lower:]' | \
265 sed -e 's/\(cygwin\).*/cygwin/')
267 export HOSTARCH HOSTOS
269 #########################################################################
271 # set default to nothing for native builds
272 ifeq ($(HOSTARCH),$(ARCH))
276 KCONFIG_CONFIG ?= .config
277 export KCONFIG_CONFIG
279 # SHELL used by kbuild
280 CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
281 else if [ -x /bin/bash ]; then echo /bin/bash; \
282 else echo sh; fi ; fi)
284 HOST_LFS_CFLAGS := $(shell getconf LFS_CFLAGS 2>/dev/null)
285 HOST_LFS_LDFLAGS := $(shell getconf LFS_LDFLAGS 2>/dev/null)
286 HOST_LFS_LIBS := $(shell getconf LFS_LIBS 2>/dev/null)
290 KBUILD_HOSTCFLAGS := -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer \
291 $(HOST_LFS_CFLAGS) $(HOSTCFLAGS)
292 KBUILD_HOSTCXXFLAGS := -O2 $(HOST_LFS_CFLAGS) $(HOSTCXXFLAGS)
293 KBUILD_HOSTLDFLAGS := $(HOST_LFS_LDFLAGS) $(HOSTLDFLAGS)
294 KBUILD_HOSTLDLIBS := $(HOST_LFS_LIBS) $(HOSTLDLIBS)
296 # With the move to GCC 6, we have implicitly upgraded our language
297 # standard to GNU11 (see https://gcc.gnu.org/gcc-5/porting_to.html).
298 # Some Linux distributions (including RHEL7, SLES13, Debian 8) still
299 # have older compilers as their default, so we make it explicit for
300 # these that our host tools are GNU11 (i.e. C11 w/ GNU extensions).
301 CSTD_FLAG := -std=gnu11
302 KBUILD_HOSTCFLAGS += $(CSTD_FLAG)
304 ifeq ($(HOSTOS),cygwin)
305 KBUILD_HOSTCFLAGS += -ansi
308 # Mac OS X / Darwin's C preprocessor is Apple specific. It
309 # generates numerous errors and warnings. We want to bypass it
310 # and use GNU C's cpp. To do this we pass the -traditional-cpp
311 # option to the compiler. Note that the -traditional-cpp flag
312 # DOES NOT have the same semantics as GNU C's flag, all it does
313 # is invoke the GNU preprocessor in stock ANSI/ISO C fashion.
315 # Apple's linker is similar, thanks to the new 2 stage linking
316 # multiple symbol definitions are treated as errors, hence the
317 # -multiply_defined suppress option to turn off this error.
319 ifeq ($(HOSTOS),darwin)
320 # get major and minor product version (e.g. '10' and '6' for Snow Leopard)
321 DARWIN_MAJOR_VERSION = $(shell sw_vers -productVersion | cut -f 1 -d '.')
322 DARWIN_MINOR_VERSION = $(shell sw_vers -productVersion | cut -f 2 -d '.')
324 os_x_before = $(shell if [ $(DARWIN_MAJOR_VERSION) -le $(1) -a \
325 $(DARWIN_MINOR_VERSION) -le $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)
327 os_x_after = $(shell if [ $(DARWIN_MAJOR_VERSION) -ge $(1) -a \
328 $(DARWIN_MINOR_VERSION) -ge $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)
330 # Snow Leopards build environment has no longer restrictions as described above
331 HOSTCC = $(call os_x_before, 10, 5, "cc", "gcc")
332 KBUILD_HOSTCFLAGS += $(call os_x_before, 10, 4, "-traditional-cpp")
333 KBUILD_HOSTLDFLAGS += $(call os_x_before, 10, 5, "-multiply_defined suppress")
335 # macOS Mojave (10.14.X)
336 # Undefined symbols for architecture x86_64: "_PyArg_ParseTuple"
337 KBUILD_HOSTLDFLAGS += $(call os_x_after, 10, 14, "-lpython -dynamclib", "")
340 # Decide whether to build built-in, modular, or both.
341 # Normally, just do built-in.
346 # If we have only "make modules", don't compile built-in objects.
347 # When we're building modules with modversions, we need to consider
348 # the built-in objects during the descend as well, in order to
349 # make sure the checksums are up to date before we record them.
351 ifeq ($(MAKECMDGOALS),modules)
352 KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
355 # If we have "make <whatever> modules", compile modules
356 # in addition to whatever we do anyway.
357 # Just "make" or "make all" shall build modules as well
359 # U-Boot does not need modules
360 #ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
361 # KBUILD_MODULES := 1
364 #ifeq ($(MAKECMDGOALS),)
365 # KBUILD_MODULES := 1
368 # Check ths size of a binary:
371 # #2: Size limit in bytes (decimal or 0xhex)
373 actual=$$( wc -c $1 | awk '{print $$1}'); \
374 limit=$$( printf "%d" $2 ); \
375 if test $$actual -gt $$limit; then \
376 echo "$1 exceeds file size limit:" >&2; \
377 echo " limit: $$(printf %#x $$limit) bytes" >&2; \
378 echo " actual: $$(printf %#x $$actual) bytes" >&2; \
379 echo " excess: $$(printf %#x $$((actual - limit))) bytes" >&2;\
385 export KBUILD_MODULES KBUILD_BUILTIN
386 export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD
388 # We need some generic definitions (do not try to remake the file).
389 scripts/Kbuild.include: ;
390 include scripts/Kbuild.include
392 # Make variables (CC, etc...)
394 AS = $(CROSS_COMPILE)as
396 ifneq ($(shell $(CROSS_COMPILE)ld.bfd -v 2> /dev/null),)
397 LD = $(CROSS_COMPILE)ld.bfd
399 LD = $(CROSS_COMPILE)ld
401 CC = $(CROSS_COMPILE)gcc
403 AR = $(CROSS_COMPILE)ar
404 NM = $(CROSS_COMPILE)nm
405 LDR = $(CROSS_COMPILE)ldr
406 STRIP = $(CROSS_COMPILE)strip
407 OBJCOPY = $(CROSS_COMPILE)objcopy
408 OBJDUMP = $(CROSS_COMPILE)objdump
417 # The devicetree compiler and pylibfdt are automatically built unless DTC is
418 # provided. If DTC is provided, it is assumed the pylibfdt is available too.
419 DTC_INTREE := $(objtree)/scripts/dtc/dtc
421 DTC_MIN_VERSION := 010406
425 CHECKFLAGS := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ \
426 -Wbitwise -Wno-return-void -D__CHECK_ENDIAN__ $(CF)
428 KBUILD_CPPFLAGS := -D__KERNEL__ -D__UBOOT__
430 KBUILD_CFLAGS := -Wall -Wstrict-prototypes \
431 -Wno-format-security \
432 -fno-builtin -ffreestanding $(CSTD_FLAG)
433 KBUILD_CFLAGS += -fshort-wchar -fno-strict-aliasing
434 KBUILD_AFLAGS := -D__ASSEMBLY__
437 ifeq ($(cc-name),clang)
438 ifneq ($(CROSS_COMPILE),)
439 CLANG_TARGET := --target=$(notdir $(CROSS_COMPILE:%-=%))
440 GCC_TOOLCHAIN_DIR := $(dir $(shell which $(LD)))
441 CLANG_PREFIX := --prefix=$(GCC_TOOLCHAIN_DIR)
442 GCC_TOOLCHAIN := $(realpath $(GCC_TOOLCHAIN_DIR)/..)
444 ifneq ($(GCC_TOOLCHAIN),)
445 CLANG_GCC_TC := --gcc-toolchain=$(GCC_TOOLCHAIN)
447 KBUILD_CFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
448 KBUILD_AFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
449 KBUILD_CFLAGS += $(call cc-option, -no-integrated-as)
450 KBUILD_AFLAGS += $(call cc-option, -no-integrated-as)
453 # Don't generate position independent code
454 KBUILD_CFLAGS += $(call cc-option,-fno-PIE)
455 KBUILD_AFLAGS += $(call cc-option,-fno-PIE)
457 # Read UBOOTRELEASE from include/config/uboot.release (if it exists)
458 UBOOTRELEASE = $(shell cat include/config/uboot.release 2> /dev/null)
459 UBOOTVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)
461 export VERSION PATCHLEVEL SUBLEVEL UBOOTRELEASE UBOOTVERSION
462 export ARCH CPU BOARD VENDOR SOC CPUDIR BOARDDIR
463 export CONFIG_SHELL HOSTCC KBUILD_HOSTCFLAGS CROSS_COMPILE AS LD CC
464 export CPP AR NM LDR STRIP OBJCOPY OBJDUMP KBUILD_HOSTLDFLAGS KBUILD_HOSTLDLIBS
465 export MAKE LEX YACC AWK PERL PYTHON PYTHON2 PYTHON3
466 export HOSTCXX KBUILD_HOSTCXXFLAGS CHECK CHECKFLAGS DTC DTC_FLAGS
468 export KBUILD_CPPFLAGS NOSTDINC_FLAGS UBOOTINCLUDE OBJCOPYFLAGS KBUILD_LDFLAGS
469 export KBUILD_CFLAGS KBUILD_AFLAGS
471 export CC_VERSION_TEXT := $(shell $(CC) --version | head -n 1)
473 # When compiling out-of-tree modules, put MODVERDIR in the module
474 # tree rather than in the kernel tree. The kernel tree might
476 export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions
478 # Files to ignore in find ... statements
480 export RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o \
481 -name CVS -o -name .pc -o -name .hg -o -name .git \) \
483 export RCS_TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn \
484 --exclude CVS --exclude .pc --exclude .hg --exclude .git
486 # ===========================================================================
487 # Rules shared between *config targets and build targets
489 # Basic helpers built in scripts/
490 PHONY += scripts_basic
492 $(Q)$(MAKE) $(build)=scripts/basic
493 $(Q)rm -f .tmp_quiet_recordmcount
495 # To avoid any implicit rule to kick in, define an empty command.
496 scripts/basic/%: scripts_basic ;
498 PHONY += outputmakefile
499 # outputmakefile generates a Makefile in the output directory, if using a
500 # separate output directory. This allows convenient use of make in the
503 ifneq ($(KBUILD_SRC),)
504 $(Q)ln -fsn $(srctree) source
505 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/mkmakefile $(srctree)
508 # To make sure we do not include .config for any of the *config targets
509 # catch them early, and hand them over to scripts/kconfig/Makefile
510 # It is allowed to specify more targets when calling make, including
511 # mixing *config targets and build targets.
512 # For example 'make oldconfig all'.
513 # Detect when mixed targets is specified, and make a second invocation
514 # of make so .config is not included in this case either (for *config).
516 version_h := include/generated/version_autogenerated.h
517 timestamp_h := include/generated/timestamp_autogenerated.h
518 defaultenv_h := include/generated/defaultenv_autogenerated.h
519 dt_h := include/generated/dt.h
520 env_h := include/generated/environment.h
522 no-dot-config-targets := clean clobber mrproper distclean \
523 help %docs check% coccicheck \
524 ubootversion backup tests check qcheck tcheck pylint
530 ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
531 ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
536 ifeq ($(KBUILD_EXTMOD),)
537 ifneq ($(filter config %config,$(MAKECMDGOALS)),)
539 ifneq ($(words $(MAKECMDGOALS)),1)
545 ifeq ($(mixed-targets),1)
546 # ===========================================================================
547 # We're called with mixed targets (*config and build targets).
548 # Handle them one by one.
550 PHONY += $(MAKECMDGOALS) __build_one_by_one
552 $(filter-out __build_one_by_one, $(MAKECMDGOALS)): __build_one_by_one
557 for i in $(MAKECMDGOALS); do \
558 $(MAKE) -f $(srctree)/Makefile $$i; \
562 ifeq ($(config-targets),1)
563 # ===========================================================================
564 # *config targets only - make sure prerequisites are updated, and descend
565 # in scripts/kconfig to make the *config target
567 KBUILD_DEFCONFIG := sandbox_defconfig
568 export KBUILD_DEFCONFIG KBUILD_KCONFIG
570 config: scripts_basic outputmakefile FORCE
571 $(Q)$(MAKE) $(build)=scripts/kconfig $@
573 %config: scripts_basic outputmakefile FORCE
574 $(Q)$(MAKE) $(build)=scripts/kconfig $@
577 # ===========================================================================
578 # Build targets only - this includes vmlinux, arch specific targets, clean
579 # targets and others. In general all targets except *config targets.
581 # Additional helpers built in scripts/
582 # Carefully list dependencies so we do not try to build scripts twice
585 scripts: scripts_basic scripts_dtc include/config/auto.conf
586 $(Q)$(MAKE) $(build)=$(@)
588 ifeq ($(dot-config),1)
590 -include include/config/auto.conf
592 # Read in dependencies to all Kconfig* files, make sure to run
593 # oldconfig if changes are detected.
594 -include include/config/auto.conf.cmd
596 # To avoid any implicit rule to kick in, define an empty command
597 $(KCONFIG_CONFIG) include/config/auto.conf.cmd: ;
599 # If .config is newer than include/config/auto.conf, someone tinkered
600 # with it and forgot to run make oldconfig.
601 # if auto.conf.cmd is missing then we are probably in a cleaned tree so
602 # we execute the config step to be sure to catch updated Kconfig files
603 include/config/%.conf: $(KCONFIG_CONFIG) include/config/auto.conf.cmd
604 $(Q)$(MAKE) -f $(srctree)/Makefile syncconfig
605 @# If the following part fails, include/config/auto.conf should be
606 @# deleted so "make silentoldconfig" will be re-run on the next build.
607 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf || \
608 { rm -f include/config/auto.conf; false; }
609 @# include/config.h has been updated after "make silentoldconfig".
610 @# We need to touch include/config/auto.conf so it gets newer
611 @# than include/config.h.
612 @# Otherwise, 'make silentoldconfig' would be invoked twice.
613 $(Q)touch include/config/auto.conf
615 u-boot.cfg spl/u-boot.cfg tpl/u-boot.cfg:
616 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf $(@)
618 -include include/autoconf.mk
619 -include include/autoconf.mk.dep
621 # We want to include arch/$(ARCH)/config.mk only when include/config/auto.conf
622 # is up-to-date. When we switch to a different board configuration, old CONFIG
623 # macros are still remaining in include/config/auto.conf. Without the following
624 # gimmick, wrong config.mk would be included leading nasty warnings/errors.
625 ifneq ($(wildcard $(KCONFIG_CONFIG)),)
626 ifneq ($(wildcard include/config/auto.conf),)
627 autoconf_is_old := $(shell find . -path ./$(KCONFIG_CONFIG) -newer \
628 include/config/auto.conf)
629 ifeq ($(autoconf_is_old),)
631 include arch/$(ARCH)/Makefile
636 # These are set by the arch-specific config.mk. Make sure they are exported
637 # so they can be used when building an EFI application.
638 export EFI_LDS # Filename of EFI link script in arch/$(ARCH)/lib
639 export EFI_CRT0 # Filename of EFI CRT0 in arch/$(ARCH)/lib
640 export EFI_RELOC # Filename of EFU relocation code in arch/$(ARCH)/lib
641 export CFLAGS_EFI # Compiler flags to add when building EFI app
642 export CFLAGS_NON_EFI # Compiler flags to remove when building EFI app
643 export EFI_TARGET # binutils target if EFI is natively supported
645 # If board code explicitly specified LDSCRIPT or CONFIG_SYS_LDSCRIPT, use
646 # that (or fail if absent). Otherwise, search for a linker script in a
650 #LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds.debug
651 ifdef CONFIG_SYS_LDSCRIPT
652 # need to strip off double quotes
653 LDSCRIPT := $(srctree)/$(CONFIG_SYS_LDSCRIPT:"%"=%)
657 # If there is no specified link script, we look in a number of places for it
659 ifeq ($(wildcard $(LDSCRIPT)),)
660 LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds
662 ifeq ($(wildcard $(LDSCRIPT)),)
663 LDSCRIPT := $(srctree)/$(CPUDIR)/u-boot.lds
665 ifeq ($(wildcard $(LDSCRIPT)),)
666 LDSCRIPT := $(srctree)/arch/$(ARCH)/cpu/u-boot.lds
671 # Dummy target needed, because used as prerequisite
672 include/config/auto.conf: ;
673 endif # $(dot-config)
676 # Xtensa linker script cannot be preprocessed with -ansi because of
677 # preprocessor operations on strings that don't make C identifiers.
679 ifeq ($(CONFIG_XTENSA),)
683 ifdef CONFIG_CC_OPTIMIZE_FOR_SIZE
691 export LTO_CFLAGS LTO_FINAL_LDFLAGS
693 ifeq ($(cc-name),clang)
695 LTO_FINAL_LDFLAGS += -flto
697 AR = $(shell $(CC) -print-prog-name=llvm-ar)
698 NM = $(shell $(CC) -print-prog-name=llvm-nm)
700 NPROC := $(shell nproc 2>/dev/null || echo 1)
701 LTO_CFLAGS += -flto=$(NPROC)
702 LTO_FINAL_LDFLAGS += -fuse-linker-plugin -flto=$(NPROC)
704 # use plugin aware tools
705 AR = $(CROSS_COMPILE)gcc-ar
706 NM = $(CROSS_COMPILE)gcc-nm
709 CFLAGS_NON_EFI += $(LTO_CFLAGS)
711 KBUILD_CFLAGS += $(LTO_CFLAGS)
714 ifeq ($(CONFIG_STACKPROTECTOR),y)
715 KBUILD_CFLAGS += $(call cc-option,-fstack-protector-strong)
716 CFLAGS_EFI += $(call cc-option,-fno-stack-protector)
718 KBUILD_CFLAGS += $(call cc-option,-fno-stack-protector)
720 KBUILD_CFLAGS += $(call cc-option,-fno-delete-null-pointer-checks)
722 # disable pointer signed / unsigned warnings in gcc 4.0
723 KBUILD_CFLAGS += -Wno-pointer-sign
725 # disable stringop warnings in gcc 8+
726 KBUILD_CFLAGS += $(call cc-disable-warning, stringop-truncation)
728 KBUILD_CFLAGS += $(call cc-disable-warning, zero-length-bounds)
729 KBUILD_CFLAGS += $(call cc-disable-warning, array-bounds)
730 KBUILD_CFLAGS += $(call cc-disable-warning, stringop-overflow)
732 # Enabled with W=2, disabled by default as noisy
733 KBUILD_CFLAGS += $(call cc-disable-warning, maybe-uninitialized)
735 # change __FILE__ to the relative path from the srctree
736 KBUILD_CFLAGS += $(call cc-option,-fmacro-prefix-map=$(srctree)/=)
739 # $(KBUILD_AFLAGS) sets -g, which causes gcc to pass a suitable -g<format>
740 # option to the assembler.
743 # Report stack usage if supported
744 # ARC tools based on GCC 7.1 has an issue with stack usage
745 # with naked functions, see commit message for more details
747 ifeq ($(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-stack-usage.sh $(CC)),y)
748 KBUILD_CFLAGS += -fstack-usage
752 KBUILD_CFLAGS += $(call cc-option,-Wno-format-nonliteral)
753 KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
755 ifdef CONFIG_CC_IS_CLANG
756 KBUILD_CPPFLAGS += $(call cc-option,-Qunused-arguments,)
757 KBUILD_CFLAGS += $(call cc-disable-warning, format-invalid-specifier)
758 KBUILD_CFLAGS += $(call cc-disable-warning, gnu)
759 KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
760 # Quiet clang warning: comparison of unsigned expression < 0 is always false
761 KBUILD_CFLAGS += $(call cc-disable-warning, tautological-compare)
762 # CLANG uses a _MergedGlobals as optimization, but this breaks modpost, as the
763 # source of a reference will be _MergedGlobals and not on of the whitelisted names.
764 # See modpost pattern 2
765 KBUILD_CFLAGS += $(call cc-option, -mno-global-merge,)
766 KBUILD_CFLAGS += $(call cc-option, -fcatch-undefined-behavior)
769 # These warnings generated too much noise in a regular build.
770 # Use make W=1 to enable them (see scripts/Makefile.extrawarn)
771 KBUILD_CFLAGS += $(call cc-disable-warning, unused-but-set-variable)
773 # Prohibit date/time macros, which would make the build non-deterministic
774 KBUILD_CFLAGS += $(call cc-option,-Werror=date-time)
776 include scripts/Makefile.extrawarn
778 # Add user supplied CPPFLAGS, AFLAGS and CFLAGS as the last assignments
779 KBUILD_CPPFLAGS += $(KCPPFLAGS)
780 KBUILD_AFLAGS += $(KAFLAGS)
781 KBUILD_CFLAGS += $(KCFLAGS)
783 KBUILD_HOSTCFLAGS += $(if $(CONFIG_TOOLS_DEBUG),-g)
785 # Use UBOOTINCLUDE when you must reference the include/ directory.
786 # Needed to be compatible with the O= option
789 $(if $(KBUILD_SRC), -I$(srctree)/include) \
790 $(if $(CONFIG_$(SPL_)SYS_THUMB_BUILD), \
791 $(if $(CONFIG_HAS_THUMB2), \
792 $(if $(CONFIG_CPU_V7M), \
793 -I$(srctree)/arch/arm/thumb1/include), \
794 -I$(srctree)/arch/arm/thumb1/include)) \
795 -I$(srctree)/arch/$(ARCH)/include \
796 -include $(srctree)/include/linux/kconfig.h
798 NOSTDINC_FLAGS += -nostdinc -isystem $(shell $(CC) -print-file-name=include)
801 cpp_flags := $(KBUILD_CPPFLAGS) $(PLATFORM_CPPFLAGS) $(UBOOTINCLUDE) \
803 c_flags := $(KBUILD_CFLAGS) $(cpp_flags)
805 #########################################################################
806 # U-Boot objects....order is important (i.e. start must be first)
808 HAVE_VENDOR_COMMON_LIB = $(if $(wildcard $(srctree)/board/$(VENDOR)/common/Makefile),y,n)
810 libs-$(CONFIG_API) += api/
811 libs-$(HAVE_VENDOR_COMMON_LIB) += board/$(VENDOR)/common/
815 libs-$(CONFIG_OF_EMBED) += dts/
822 libs-$(CONFIG_SYS_FSL_DDR) += drivers/ddr/fsl/
823 libs-$(CONFIG_SYS_FSL_MMDC) += drivers/ddr/fsl/
824 libs-$(CONFIG_$(SPL_)ALTERA_SDRAM) += drivers/ddr/altera/
825 libs-y += drivers/usb/cdns3/
826 libs-y += drivers/usb/dwc3/
827 libs-y += drivers/usb/common/
828 libs-y += drivers/usb/emul/
829 libs-y += drivers/usb/eth/
830 libs-$(CONFIG_USB_DEVICE) += drivers/usb/gadget/
831 libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/
832 libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/udc/
833 libs-y += drivers/usb/host/
834 libs-y += drivers/usb/mtu3/
835 libs-y += drivers/usb/musb/
836 libs-y += drivers/usb/musb-new/
837 libs-y += drivers/usb/phy/
838 libs-y += drivers/usb/ulpi/
842 libs-$(CONFIG_UNIT_TEST) += test/
843 libs-$(CONFIG_UT_ENV) += test/env/
844 libs-$(CONFIG_UT_OPTEE) += test/optee/
845 libs-$(CONFIG_UT_OVERLAY) += test/overlay/
847 libs-y += $(if $(BOARDDIR),board/$(BOARDDIR)/)
849 libs-y := $(sort $(libs-y))
851 u-boot-dirs := $(patsubst %/,%,$(filter %/, $(libs-y))) tools examples
853 u-boot-alldirs := $(sort $(u-boot-dirs) $(patsubst %/,%,$(filter %/, $(libs-))))
855 libs-y := $(patsubst %/, %/built-in.o, $(libs-y))
857 u-boot-init := $(head-y)
858 u-boot-main := $(libs-y)
862 ifeq ($(CONFIG_USE_PRIVATE_LIBGCC),y)
863 PLATFORM_LIBGCC = arch/$(ARCH)/lib/lib.a
865 PLATFORM_LIBGCC := -L $(shell dirname `$(CC) $(c_flags) -print-libgcc-file-name`) -lgcc
867 PLATFORM_LIBS += $(PLATFORM_LIBGCC)
869 ifdef CONFIG_CC_COVERAGE
870 KBUILD_CFLAGS += --coverage
871 PLATFORM_LIBGCC += -lgcov
875 export PLATFORM_LIBGCC
877 # Special flags for CPP when processing the linker script.
878 # Pass the version down so we can handle backwards compatibility
881 -include $(srctree)/include/u-boot/u-boot.lds.h \
883 $(shell $(LD) --version | \
884 sed -ne 's/GNU ld version \([0-9][0-9]*\)\.\([0-9][0-9]*\).*/-DLD_MAJOR=\1 -DLD_MINOR=\2/p')
886 #########################################################################
887 #########################################################################
889 ifneq ($(CONFIG_BOARD_SIZE_LIMIT),)
890 BOARD_SIZE_CHECK= @ $(call size_check,$@,$(CONFIG_BOARD_SIZE_LIMIT))
895 ifneq ($(CONFIG_SPL_SIZE_LIMIT),0x0)
896 SPL_SIZE_CHECK = @$(call size_check,$@,$$(tools/spl_size_limit))
901 ifneq ($(CONFIG_TPL_SIZE_LIMIT),0x0)
902 TPL_SIZE_CHECK = @$(call size_check,$@,$(CONFIG_TPL_SIZE_LIMIT))
907 # Statically apply RELA-style relocations (currently arm64 only)
908 # This is useful for arm64 where static relocation needs to be performed on
909 # the raw binary, but certain simulators only accept an ELF file (but don't
910 # do the relocation).
911 ifneq ($(CONFIG_STATIC_RELA),)
912 # $(1) is u-boot ELF, $(2) is u-boot bin, $(3) is text base
913 quiet_cmd_static_rela = RELOC $@
915 start=$$($(NM) $(2) | grep __rel_dyn_start | cut -f 1 -d ' '); \
916 end=$$($(NM) $(2) | grep __rel_dyn_end | cut -f 1 -d ' '); \
917 tools/relocate-rela $(3) $(4) $$start $$end
919 quiet_cmd_static_rela =
923 # Always append INPUTS so that arch config.mk's can add custom ones
924 INPUTS-y += u-boot.srec u-boot.bin u-boot.sym System.map binary_size_check
926 INPUTS-$(CONFIG_ONENAND_U_BOOT) += u-boot-onenand.bin
927 ifeq ($(CONFIG_SPL_FSL_PBL),y)
928 INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot-with-spl-pbl.bin
930 ifneq ($(CONFIG_NXP_ESBC), y)
931 # For Secure Boot The Image needs to be signed and Header must also
932 # be included. So The image has to be built explicitly
933 INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot.pbl
936 INPUTS-$(CONFIG_SPL) += spl/u-boot-spl.bin
937 ifeq ($(CONFIG_MX6)$(CONFIG_IMX_HAB), yy)
938 INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
940 ifeq ($(CONFIG_MX7)$(CONFIG_IMX_HAB), yy)
941 INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
943 INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot.img
946 INPUTS-$(CONFIG_TPL) += tpl/u-boot-tpl.bin
948 # Allow omitting the .dtb output if it is not normally used
949 INPUTS-$(CONFIG_OF_SEPARATE) += $(if $(CONFIG_OF_OMIT_DTB),dts/dt.dtb,u-boot.dtb)
950 ifeq ($(CONFIG_SPL_FRAMEWORK),y)
951 INPUTS-$(CONFIG_OF_SEPARATE) += u-boot-dtb.img
953 INPUTS-$(CONFIG_SANDBOX) += u-boot.dtb
954 ifneq ($(CONFIG_SPL_TARGET),)
955 INPUTS-$(CONFIG_SPL) += $(CONFIG_SPL_TARGET:"%"=%)
957 INPUTS-$(CONFIG_REMAKE_ELF) += u-boot.elf
958 INPUTS-$(CONFIG_EFI_APP) += u-boot-app.efi
959 INPUTS-$(CONFIG_EFI_STUB) += u-boot-payload.efi
961 # Generate this input file for binman
962 ifeq ($(CONFIG_SPL),)
963 INPUTS-$(CONFIG_ARCH_MEDIATEK) += u-boot-mtk.bin
966 # Add optional build target if defined in board/cpu/soc headers
967 ifneq ($(CONFIG_BUILD_TARGET),)
968 INPUTS-y += $(CONFIG_BUILD_TARGET:"%"=%)
971 ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
972 INPUTS-y += init_sp_bss_offset_check
975 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
976 INPUTS-y += u-boot-with-dtb.bin
979 ifeq ($(CONFIG_ARCH_ROCKCHIP),y)
980 # On ARM64 this target is produced by binman so we don't need this dep
981 ifeq ($(CONFIG_ARM64),y)
982 ifeq ($(CONFIG_SPL),y)
983 # TODO: Get binman to generate this too
984 INPUTS-y += u-boot-rockchip.bin
987 ifeq ($(CONFIG_SPL),y)
988 # Generate these inputs for binman which will create the output files
989 INPUTS-y += idbloader.img u-boot.img
994 INPUTS-$(CONFIG_X86) += u-boot-x86-start16.bin u-boot-x86-reset16.bin \
995 $(if $(CONFIG_SPL_X86_16BIT_INIT),spl/u-boot-spl.bin) \
996 $(if $(CONFIG_TPL_X86_16BIT_INIT),tpl/u-boot-tpl.bin)
998 LDFLAGS_u-boot += $(LDFLAGS_FINAL)
1000 # Avoid 'Not enough room for program headers' error on binutils 2.28 onwards.
1001 LDFLAGS_u-boot += $(call ld-option, --no-dynamic-linker)
1004 LDFLAGS_u-boot += -z notext
1006 LDFLAGS_u-boot += --build-id=none
1008 ifeq ($(CONFIG_ARC)$(CONFIG_NIOS2)$(CONFIG_X86)$(CONFIG_XTENSA),)
1009 LDFLAGS_u-boot += -Ttext $(CONFIG_SYS_TEXT_BASE)
1012 # insure the checker run with the right endianness
1013 CHECKFLAGS += $(if $(CONFIG_CPU_BIG_ENDIAN),-mbig-endian,-mlittle-endian)
1015 # the checker needs the correct machine size
1016 CHECKFLAGS += $(if $(CONFIG_64BIT),-m64,-m32)
1018 # Normally we fill empty space with 0xff
1019 quiet_cmd_objcopy = OBJCOPY $@
1020 cmd_objcopy = $(OBJCOPY) --gap-fill=0xff $(OBJCOPYFLAGS) \
1021 $(OBJCOPYFLAGS_$(@F)) $< $@
1023 # Provide a version which does not do this, for use by EFI
1024 quiet_cmd_zobjcopy = OBJCOPY $@
1025 cmd_zobjcopy = $(OBJCOPY) $(OBJCOPYFLAGS) $(OBJCOPYFLAGS_$(@F)) $< $@
1027 quiet_cmd_efipayload = OBJCOPY $@
1028 cmd_efipayload = $(OBJCOPY) -I binary -O $(EFIPAYLOAD_BFDTARGET) -B $(EFIPAYLOAD_BFDARCH) $< $@
1030 MKIMAGEOUTPUT ?= /dev/null
1032 quiet_cmd_mkimage = MKIMAGE $@
1033 cmd_mkimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) -d $< $@ \
1034 >$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
1036 quiet_cmd_mkfitimage = MKIMAGE $@
1037 cmd_mkfitimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) \
1038 -f $(U_BOOT_ITS) -p $(CONFIG_FIT_EXTERNAL_OFFSET) $@ \
1039 >$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
1041 quiet_cmd_cat = CAT $@
1042 cmd_cat = cat $(filter-out $(PHONY), $^) > $@
1044 append = cat $(filter-out $< $(PHONY), $^) >> $@
1046 quiet_cmd_pad_cat = CAT $@
1047 cmd_pad_cat = $(cmd_objcopy) && $(append) || { rm -f $@; false; }
1049 quiet_cmd_lzma = LZMA $@
1050 cmd_lzma = lzma -c -z -k -9 $< > $@
1054 quiet_cmd_cfgcheck = CFGCHK $2
1055 cmd_cfgcheck = $(srctree)/scripts/check-config.sh $2 \
1056 $(srctree)/scripts/config_whitelist.txt $(srctree)
1058 quiet_cmd_ofcheck = OFCHK $2
1059 cmd_ofcheck = $(srctree)/scripts/check-of.sh $2 \
1060 $(srctree)/scripts/of_allowlist.txt
1062 # Concat the value of all the CONFIGs (result is 'y' or 'yy', etc. )
1063 got = $(foreach cfg,$(1),$($(cfg)))
1065 # expected value 'y for each one
1066 expect = $(foreach cfg,$(1),y)
1068 # Show a deprecation message
1070 # 1: List of CONFIG_DM_... to migrate to (e.g. "CONFIG_DM_MMC CONFIG_BLK")
1071 # 2: Name of component (e.g . "Ethernet drivers")
1072 # 3: Release deadline (e.g. "v202.07")
1073 # 4: Condition to require before checking (e.g. "$(CONFIG_NET)")
1074 # Note: Script avoids bash construct, hence the strange double 'if'
1075 # (patches welcome!)
1077 @if [ -n "$(strip $(4))" ]; then if [ "$(got)" != "$(expect)" ]; then \
1078 echo >&2 "===================== WARNING ======================"; \
1079 echo >&2 "This board does not use $(firstword $(1)) (Driver Model"; \
1080 echo >&2 "for $(2)). Please update the board to use"; \
1081 echo >&2 "$(firstword $(1)) before the $(3) release. Failure to"; \
1082 echo >&2 "update by the deadline may result in board removal."; \
1083 echo >&2 "See doc/driver-model/migration.rst for more info."; \
1084 echo >&2 "===================================================="; \
1092 all: .binman_stamp inputs
1093 ifeq ($(CONFIG_BINMAN),y)
1094 $(call if_changed,binman)
1097 # Timestamp file to make sure that binman always runs
1098 .binman_stamp: FORCE
1101 ifeq ($(CONFIG_DEPRECATED),y)
1102 $(warning "You have deprecated configuration options enabled in your .config! Please check your configuration.")
1104 ifeq ($(CONFIG_OF_EMBED)$(CONFIG_EFI_APP),y)
1105 @echo >&2 "===================== WARNING ======================"
1106 @echo >&2 "CONFIG_OF_EMBED is enabled. This option should only"
1107 @echo >&2 "be used for debugging purposes. Please use"
1108 @echo >&2 "CONFIG_OF_SEPARATE for boards in mainline."
1109 @echo >&2 "See doc/README.fdt-control for more info."
1110 @echo >&2 "===================================================="
1112 ifneq ($(CONFIG_SPL_FIT_GENERATOR),)
1113 @echo >&2 "===================== WARNING ======================"
1114 @echo >&2 "This board uses CONFIG_SPL_FIT_GENERATOR. Please migrate"
1115 @echo >&2 "to binman instead, to avoid the proliferation of"
1116 @echo >&2 "arch-specific scripts with no tests."
1117 @echo >&2 "===================================================="
1119 ifneq ($(CONFIG_DM),y)
1120 @echo >&2 "===================== WARNING ======================"
1121 @echo >&2 "This board does not use CONFIG_DM. CONFIG_DM will be"
1122 @echo >&2 "compulsory starting with the v2020.01 release."
1123 @echo >&2 "Failure to update may result in board removal."
1124 @echo >&2 "See doc/driver-model/migration.rst for more info."
1125 @echo >&2 "===================================================="
1127 $(call deprecated,CONFIG_WDT,DM watchdog,v2019.10,\
1128 $(CONFIG_WATCHDOG)$(CONFIG_HW_WATCHDOG))
1129 $(call deprecated,CONFIG_DM_ETH,Ethernet drivers,v2020.07,$(CONFIG_NET))
1130 $(call deprecated,CONFIG_DM_I2C,I2C drivers,v2022.04,$(CONFIG_SYS_I2C_LEGACY))
1131 $(call deprecated,CONFIG_DM_KEYBOARD,Keyboard drivers,v2022.10,$(CONFIG_KEYBOARD))
1132 @# CONFIG_SYS_TIMER_RATE has brackets in it for some boards which
1133 @# confuses this rule. Use if() to send just a single character which
1134 @# is enable to tell 'deprecated' that one of these symbols exists
1135 $(call deprecated,CONFIG_TIMER,Timer drivers,v2023.01,$(if $(strip $(CONFIG_SYS_TIMER_RATE)$(CONFIG_SYS_TIMER_COUNTER)),x))
1136 $(call deprecated,CONFIG_DM_SERIAL,Serial drivers,v2023.04,$(CONFIG_SERIAL))
1137 @# Check that this build does not use CONFIG options that we do not
1138 @# know about unless they are in Kconfig. All the existing CONFIG
1139 @# options are whitelisted, so new ones should not be added.
1140 $(call cmd,cfgcheck,u-boot.cfg)
1141 @# Check that this build does not override OF_HAS_PRIOR_STAGE by
1142 @# disabling OF_BOARD.
1143 $(call cmd,ofcheck,$(KCONFIG_CONFIG))
1149 $(Q)$(MAKE) $(build)=dts dtbs
1151 quiet_cmd_copy = COPY $@
1154 ifeq ($(CONFIG_MULTI_DTB_FIT),y)
1156 ifeq ($(CONFIG_MULTI_DTB_FIT_LZO),y)
1157 FINAL_DTB_CONTAINER = fit-dtb.blob.lzo
1158 else ifeq ($(CONFIG_MULTI_DTB_FIT_GZIP),y)
1159 FINAL_DTB_CONTAINER = fit-dtb.blob.gz
1161 FINAL_DTB_CONTAINER = fit-dtb.blob
1164 fit-dtb.blob.gz: fit-dtb.blob
1167 fit-dtb.blob.lzo: fit-dtb.blob
1170 fit-dtb.blob: dts/dt.dtb FORCE
1171 $(call if_changed,mkimage)
1172 ifneq ($(SOURCE_DATE_EPOCH),)
1173 touch -d @$(SOURCE_DATE_EPOCH) fit-dtb.blob
1174 chmod 0600 fit-dtb.blob
1177 MKIMAGEFLAGS_fit-dtb.blob = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
1179 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) -d /dev/null
1181 MKIMAGEFLAGS_fit-dtb.blob += -B 0x8
1184 u-boot-fit-dtb.bin: u-boot-nodtb.bin $(EXT_DTB)
1185 $(call if_changed,cat)
1187 u-boot-fit-dtb.bin: u-boot-nodtb.bin $(FINAL_DTB_CONTAINER)
1188 $(call if_changed,cat)
1191 u-boot.bin: u-boot-fit-dtb.bin FORCE
1192 $(call if_changed,copy)
1194 u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
1195 $(call if_changed,cat)
1197 else ifeq ($(CONFIG_OF_SEPARATE).$(CONFIG_OF_OMIT_DTB),y.)
1198 u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
1199 $(call if_changed,cat)
1201 u-boot.bin: u-boot-dtb.bin FORCE
1202 $(call if_changed,copy)
1204 u-boot.bin: u-boot-nodtb.bin FORCE
1205 $(call if_changed,copy)
1208 # we call Makefile in arch/arm/mach-imx which
1209 # has targets which are dependent on targets defined
1210 # here. make could not resolve them and we must ensure
1211 # that they are finished before calling imx targets
1212 ifeq ($(CONFIG_MULTI_DTB_FIT),y)
1213 IMX_DEPS = u-boot-fit-dtb.bin
1216 %.imx: $(IMX_DEPS) %.bin
1217 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1221 $(Q)$(MAKE) $(build)=arch/arm/cpu/armv7/vf610 $@
1223 quiet_cmd_copy = COPY $@
1226 u-boot.dtb: dts/dt.dtb
1229 OBJCOPYFLAGS_u-boot.hex := -O ihex
1231 OBJCOPYFLAGS_u-boot.srec := -O srec
1233 u-boot.hex u-boot.srec: u-boot FORCE
1234 $(call if_changed,objcopy)
1236 OBJCOPYFLAGS_u-boot-elf.srec := $(OBJCOPYFLAGS_u-boot.srec)
1238 u-boot-elf.srec: u-boot.elf FORCE
1239 $(call if_changed,objcopy)
1241 OBJCOPYFLAGS_u-boot-spl.srec = $(OBJCOPYFLAGS_u-boot.srec)
1243 spl/u-boot-spl.srec: spl/u-boot-spl FORCE
1244 $(call if_changed,objcopy)
1247 $(Q)$(MAKE) $(build)=arch/arm/mach-rmobile $@
1249 OBJCOPYFLAGS_u-boot-nodtb.bin := -O binary \
1250 $(if $(CONFIG_X86_16BIT_INIT),-R .start16 -R .resetvec) \
1251 $(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR),-R .bootpg -R .resetvec)
1253 binary_size_check: u-boot-nodtb.bin FORCE
1254 @file_size=$(shell wc -c u-boot-nodtb.bin | awk '{print $$1}') ; \
1255 map_size=$(shell cat u-boot.map | \
1256 awk '/_image_copy_start/ {start = $$1} /_image_binary_end/ {end = $$1} END {if (start != "" && end != "") print "ibase=16; " toupper(end) " - " toupper(start)}' \
1259 if [ "" != "$$map_size" ]; then \
1260 if test $$map_size -ne $$file_size; then \
1261 echo "u-boot.map shows a binary size of $$map_size" >&2 ; \
1262 echo " but u-boot-nodtb.bin shows $$file_size" >&2 ; \
1267 ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
1268 ifneq ($(CONFIG_SYS_MALLOC_F_LEN),)
1269 subtract_sys_malloc_f_len = space=$$(($${space} - $(CONFIG_SYS_MALLOC_F_LEN)))
1271 subtract_sys_malloc_f_len = true
1273 # The 1/4 margin below is somewhat arbitrary. The likely initial SP usage is
1274 # so low that the DTB could probably use 90%+ of the available space, for
1275 # current values of CONFIG_SYS_INIT_SP_BSS_OFFSET at least. However, let's be
1276 # safe for now and tweak this later if space becomes tight.
1277 # A rejected alternative would be to check that some absolute minimum stack
1278 # space was available. However, since CONFIG_SYS_INIT_SP_BSS_OFFSET is
1279 # deliberately build-specific, to take account of build-to-build stack usage
1280 # differences due to different feature sets, there is no common absolute value
1282 init_sp_bss_offset_check: u-boot.dtb FORCE
1283 @dtb_size=$(shell wc -c u-boot.dtb | awk '{print $$1}') ; \
1284 space=$(CONFIG_SYS_INIT_SP_BSS_OFFSET) ; \
1285 $(subtract_sys_malloc_f_len) ; \
1286 quarter_space=$$(($${space} / 4)) ; \
1287 if [ $${dtb_size} -gt $${quarter_space} ]; then \
1288 echo "u-boot.dtb is larger than 1 quarter of " >&2 ; \
1289 echo "(CONFIG_SYS_INIT_SP_BSS_OFFSET - CONFIG_SYS_MALLOC_F_LEN)" >&2 ; \
1294 shell_cmd = { $(call echo-cmd,$(1)) $(cmd_$(1)); }
1296 quiet_cmd_objcopy_uboot = OBJCOPY $@
1297 ifdef cmd_static_rela
1298 cmd_objcopy_uboot = $(cmd_objcopy) && $(call shell_cmd,static_rela,$<,$@,$(CONFIG_SYS_TEXT_BASE)) || { rm -f $@; false; }
1300 cmd_objcopy_uboot = $(cmd_objcopy)
1303 u-boot-nodtb.bin: u-boot FORCE
1304 $(call if_changed,objcopy_uboot)
1309 $(LDR) -T $(CONFIG_CPU) -c $@ $< $(LDR_FLAGS)
1313 # ---------------------------------------------------------------------------
1314 # Use 'make BINMAN_DEBUG=1' to enable debugging
1315 # Use 'make BINMAN_VERBOSE=3' to set vebosity level
1316 default_dt := $(if $(DEVICE_TREE),$(DEVICE_TREE),$(CONFIG_DEFAULT_DEVICE_TREE))
1318 quiet_cmd_binman = BINMAN $@
1319 cmd_binman = $(srctree)/tools/binman/binman $(if $(BINMAN_DEBUG),-D) \
1320 $(foreach f,$(BINMAN_TOOLPATHS),--toolpath $(f)) \
1321 --toolpath $(objtree)/tools \
1322 $(if $(BINMAN_VERBOSE),-v$(BINMAN_VERBOSE)) \
1323 build -u -d u-boot.dtb -O . -m --allow-missing \
1325 -I . -I $(srctree) -I $(srctree)/board/$(BOARDDIR) \
1326 -I arch/$(ARCH)/dts -a of-list=$(CONFIG_OF_LIST) \
1327 $(foreach f,$(BINMAN_INDIRS),-I $(f)) \
1328 -a atf-bl31-path=${BL31} \
1329 -a opensbi-path=${OPENSBI} \
1330 -a default-dt=$(default_dt) \
1331 -a scp-path=$(SCP) \
1332 -a spl-bss-pad=$(if $(CONFIG_SPL_SEPARATE_BSS),,1) \
1333 -a tpl-bss-pad=$(if $(CONFIG_TPL_SEPARATE_BSS),,1) \
1334 -a spl-dtb=$(CONFIG_SPL_OF_REAL) \
1335 -a tpl-dtb=$(CONFIG_TPL_OF_REAL) \
1338 OBJCOPYFLAGS_u-boot.ldr.hex := -I binary -O ihex
1340 OBJCOPYFLAGS_u-boot.ldr.srec := -I binary -O srec
1342 u-boot.ldr.hex u-boot.ldr.srec: u-boot.ldr FORCE
1343 $(call if_changed,objcopy)
1346 # U-Boot entry point, needed for booting of full-blown U-Boot
1347 # from the SPL U-Boot version.
1349 ifndef CONFIG_SYS_UBOOT_START
1350 CONFIG_SYS_UBOOT_START := $(CONFIG_SYS_TEXT_BASE)
1353 # Boards with more complex image requirements can provide an .its source file
1354 # or a generator script
1355 # NOTE: Please do not use this. We are migrating away from Makefile rules to use
1357 ifneq ($(CONFIG_SPL_FIT_SOURCE),"")
1358 U_BOOT_ITS := u-boot.its
1359 $(U_BOOT_ITS): $(subst ",,$(CONFIG_SPL_FIT_SOURCE))
1360 $(call if_changed,copy)
1362 ifneq ($(CONFIG_USE_SPL_FIT_GENERATOR),)
1363 U_BOOT_ITS := u-boot.its
1364 ifeq ($(CONFIG_SPL_FIT_GENERATOR),"arch/arm/mach-rockchip/make_fit_atf.py")
1365 U_BOOT_ITS_DEPS += u-boot
1367 $(U_BOOT_ITS): $(U_BOOT_ITS_DEPS) FORCE
1368 $(srctree)/$(CONFIG_SPL_FIT_GENERATOR) \
1369 $(patsubst %,arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) > $@
1373 ifdef CONFIG_SPL_LOAD_FIT
1374 MKIMAGEFLAGS_u-boot.img = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
1375 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1376 -p $(CONFIG_FIT_EXTERNAL_OFFSET) \
1377 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board" -E \
1378 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(DEVICE_TREE))) \
1379 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) \
1380 $(patsubst %,-b arch/$(ARCH)/dts/%.dtbo,$(subst ",,$(CONFIG_OF_OVERLAY_LIST)))
1382 MKIMAGEFLAGS_u-boot.img = -A $(ARCH) -T firmware -C none -O u-boot \
1383 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1384 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1385 MKIMAGEFLAGS_u-boot-ivt.img = -A $(ARCH) -T firmware_ivt -C none -O u-boot \
1386 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1387 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1388 u-boot-ivt.img: MKIMAGEOUTPUT = u-boot-ivt.img.log
1391 MKIMAGEFLAGS_u-boot-dtb.img = $(MKIMAGEFLAGS_u-boot.img)
1393 # Some boards have the kwbimage.cfg file written in advance, while some
1394 # other boards generate it on the fly during the build in the build tree.
1395 # Let's check if the file exists in the build tree first, otherwise we
1396 # fall back to use the one in the source tree.
1397 KWD_CONFIG_FILE = $(shell \
1398 if [ -f $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%) ]; then \
1399 echo -n $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
1401 echo -n $(srctree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
1404 MKIMAGEFLAGS_u-boot.kwb = -n $(KWD_CONFIG_FILE) \
1405 -T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE)
1407 MKIMAGEFLAGS_u-boot-spl.kwb = -n $(KWD_CONFIG_FILE) \
1408 -T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
1409 $(if $(KEYDIR),-k $(KEYDIR))
1411 MKIMAGEFLAGS_u-boot.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
1412 -R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -T pblimage
1414 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1415 UBOOT_BIN := u-boot-with-dtb.bin
1417 UBOOT_BIN := u-boot.bin
1420 MKIMAGEFLAGS_u-boot-lzma.img = -A $(ARCH) -T standalone -C lzma -O u-boot \
1421 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1422 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1424 u-boot.bin.lzma: u-boot.bin FORCE
1425 $(call if_changed,lzma)
1427 u-boot-lzma.img: u-boot.bin.lzma FORCE
1428 $(call if_changed,mkimage)
1430 u-boot-dtb.img u-boot.img u-boot.kwb u-boot.pbl u-boot-ivt.img: \
1431 $(if $(CONFIG_SPL_LOAD_FIT),u-boot-nodtb.bin \
1432 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SANDBOX),dts/dt.dtb) \
1433 ,$(UBOOT_BIN)) FORCE
1434 $(call if_changed,mkimage)
1437 ifeq ($(CONFIG_SPL_LOAD_FIT_FULL),y)
1438 MKIMAGEFLAGS_u-boot.itb =
1440 MKIMAGEFLAGS_u-boot.itb = -E
1442 MKIMAGEFLAGS_u-boot.itb += -B 0x8
1445 u-boot.itb: u-boot-nodtb.bin \
1446 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SANDBOX),dts/dt.dtb) \
1448 $(call if_changed,mkfitimage)
1452 u-boot-spl.kwb: u-boot.bin spl/u-boot-spl.bin FORCE
1453 $(call if_changed,mkimage)
1455 u-boot.sha1: u-boot.bin
1456 tools/ubsha1 u-boot.bin
1459 $(OBJDUMP) -d $< > $@
1461 ifneq ($(CONFIG_SPL_PAYLOAD),)
1462 SPL_PAYLOAD := $(CONFIG_SPL_PAYLOAD:"%"=%)
1464 SPL_PAYLOAD := u-boot.bin
1467 SPL_IMAGE := $(CONFIG_SPL_IMAGE:"%"=%)
1469 OBJCOPYFLAGS_u-boot-with-spl.bin = -I binary -O binary \
1470 --pad-to=$(CONFIG_SPL_PAD_TO)
1471 u-boot-with-spl.bin: $(SPL_IMAGE) $(SPL_PAYLOAD) FORCE
1472 $(call if_changed,pad_cat)
1474 ifeq ($(CONFIG_ARCH_ROCKCHIP),y)
1477 ifeq ($(CONFIG_SPL)$(CONFIG_TPL),yy)
1478 MKIMAGEFLAGS_u-boot-tpl-rockchip.bin = -n $(CONFIG_SYS_SOC) -T rksd
1479 tpl/u-boot-tpl-rockchip.bin: tpl/u-boot-tpl.bin FORCE
1480 $(call if_changed,mkimage)
1481 idbloader.img: tpl/u-boot-tpl-rockchip.bin spl/u-boot-spl.bin FORCE
1482 $(call if_changed,cat)
1484 MKIMAGEFLAGS_idbloader.img = -n $(CONFIG_SYS_SOC) -T rksd
1485 idbloader.img: spl/u-boot-spl.bin FORCE
1486 $(call if_changed,mkimage)
1489 ifeq ($(CONFIG_ARM64),y)
1490 OBJCOPYFLAGS_u-boot-rockchip.bin = -I binary -O binary \
1491 --pad-to=$(CONFIG_SPL_PAD_TO) --gap-fill=0xff
1492 u-boot-rockchip.bin: idbloader.img u-boot.itb FORCE
1493 $(call if_changed,pad_cat)
1494 endif # CONFIG_ARM64
1496 endif # CONFIG_ARCH_ROCKCHIP
1498 ifeq ($(CONFIG_ARCH_LPC32XX)$(CONFIG_SPL),yy)
1499 MKIMAGEFLAGS_lpc32xx-spl.img = -T lpc32xximage -a $(CONFIG_SPL_TEXT_BASE)
1501 lpc32xx-spl.img: spl/u-boot-spl.bin FORCE
1502 $(call if_changed,mkimage)
1504 OBJCOPYFLAGS_lpc32xx-boot-0.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1506 lpc32xx-boot-0.bin: lpc32xx-spl.img FORCE
1507 $(call if_changed,objcopy)
1509 OBJCOPYFLAGS_lpc32xx-boot-1.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1511 lpc32xx-boot-1.bin: lpc32xx-spl.img FORCE
1512 $(call if_changed,objcopy)
1514 lpc32xx-full.bin: lpc32xx-boot-0.bin lpc32xx-boot-1.bin u-boot.img FORCE
1515 $(call if_changed,cat)
1519 OBJCOPYFLAGS_u-boot-with-tpl.bin = -I binary -O binary \
1520 --pad-to=$(CONFIG_TPL_PAD_TO)
1521 tpl/u-boot-with-tpl.bin: tpl/u-boot-tpl.bin u-boot.bin FORCE
1522 $(call if_changed,pad_cat)
1524 SPL: spl/u-boot-spl.bin FORCE
1525 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1527 ifeq ($(CONFIG_ARCH_IMX8M)$(CONFIG_ARCH_IMX8), y)
1528 ifeq ($(CONFIG_SPL_LOAD_IMX_CONTAINER), y)
1529 u-boot.cnt: u-boot.bin FORCE
1530 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1532 flash.bin: spl/u-boot-spl.bin u-boot.cnt FORCE
1533 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1535 ifeq ($(CONFIG_BINMAN),y)
1536 flash.bin: spl/u-boot-spl.bin $(INPUTS-y) FORCE
1537 $(call if_changed,binman)
1539 flash.bin: spl/u-boot-spl.bin u-boot.itb FORCE
1540 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1545 u-boot.uim: u-boot.bin FORCE
1546 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1548 u-boot-with-spl.imx u-boot-with-nand-spl.imx: SPL $(if $(CONFIG_OF_SEPARATE),u-boot.img,u-boot.uim) FORCE
1549 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1551 MKIMAGEFLAGS_u-boot.ubl = -n $(UBL_CONFIG) -T ublimage -e $(CONFIG_SYS_TEXT_BASE)
1553 u-boot.ubl: u-boot-with-spl.bin FORCE
1554 $(call if_changed,mkimage)
1556 MKIMAGEFLAGS_u-boot-spl.ais = -s -n $(if $(CONFIG_AIS_CONFIG_FILE), \
1557 $(srctree)/$(CONFIG_AIS_CONFIG_FILE:"%"=%),"/dev/null") \
1558 -T aisimage -e $(CONFIG_SPL_TEXT_BASE)
1559 spl/u-boot-spl.ais: spl/u-boot-spl.bin FORCE
1560 $(call if_changed,mkimage)
1562 OBJCOPYFLAGS_u-boot.ais = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1563 u-boot.ais: spl/u-boot-spl.ais u-boot.img FORCE
1564 $(call if_changed,pad_cat)
1566 u-boot-signed.sb: u-boot.bin spl/u-boot-spl.bin
1567 $(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot-signed.sb
1568 u-boot.sb: u-boot.bin spl/u-boot-spl.bin
1569 $(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot.sb
1571 MKIMAGEFLAGS_u-boot-spl.img = -A $(ARCH) -T firmware -C none \
1572 -a $(CONFIG_SPL_TEXT_BASE) -e $(CONFIG_SPL_TEXT_BASE) -n XLOADER
1573 spl/u-boot-spl.img: spl/u-boot-spl.bin FORCE
1574 $(call if_changed,mkimage)
1576 ifneq ($(CONFIG_ARCH_SOCFPGA),)
1577 quiet_cmd_gensplx4 = GENSPLX4 $@
1578 cmd_gensplx4 = $(OBJCOPY) -I binary -O binary --gap-fill=0x0 \
1579 --pad-to=$(CONFIG_SPL_PAD_TO) \
1580 spl/u-boot-spl.sfp spl/u-boot-spl.sfp && \
1581 cat spl/u-boot-spl.sfp spl/u-boot-spl.sfp \
1582 spl/u-boot-spl.sfp spl/u-boot-spl.sfp > $@ || { rm -f $@; false; }
1583 spl/u-boot-splx4.sfp: spl/u-boot-spl.sfp FORCE
1584 $(call if_changed,gensplx4)
1586 quiet_cmd_socboot = SOCBOOT $@
1587 cmd_socboot = cat spl/u-boot-splx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1588 u-boot-with-spl.sfp: spl/u-boot-splx4.sfp u-boot.img FORCE
1589 $(call if_changed,socboot)
1591 quiet_cmd_gensplpadx4 = GENSPLPADX4 $@
1592 cmd_gensplpadx4 = dd if=/dev/zero of=spl/u-boot-spl.pad bs=64 count=1024 ; \
1593 cat spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1594 spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1595 spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1596 spl/u-boot-spl.sfp spl/u-boot-spl.pad > $@ || \
1597 { rm -f $@ spl/u-boot-spl.pad; false; }
1598 u-boot-spl-padx4.sfp: spl/u-boot-spl.sfp FORCE
1599 $(call if_changed,gensplpadx4)
1601 quiet_cmd_socnandboot = SOCNANDBOOT $@
1602 cmd_socnandboot = cat u-boot-spl-padx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1603 u-boot-with-nand-spl.sfp: u-boot-spl-padx4.sfp u-boot.img FORCE
1604 $(call if_changed,socnandboot)
1608 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1609 u-boot-with-dtb.bin: u-boot.bin u-boot.dtb \
1610 $(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR), u-boot-br.bin) FORCE
1611 $(call if_changed,binman)
1613 ifeq ($(CONFIG_MPC85XX_HAVE_RESET_VECTOR),y)
1614 OBJCOPYFLAGS_u-boot-br.bin := -O binary -j .bootpg -j .resetvec
1615 u-boot-br.bin: u-boot FORCE
1616 $(call if_changed,objcopy)
1620 quiet_cmd_ldr = LD $@
1621 cmd_ldr = $(LD) $(LDFLAGS_$(@F)) \
1622 $(filter-out FORCE,$^) -o $@
1625 OBJCOPYFLAGS_u-boot-x86-start16.bin := -O binary -j .start16
1626 u-boot-x86-start16.bin: u-boot FORCE
1627 $(call if_changed,objcopy)
1629 OBJCOPYFLAGS_u-boot-x86-reset16.bin := -O binary -j .resetvec
1630 u-boot-x86-reset16.bin: u-boot FORCE
1631 $(call if_changed,objcopy)
1635 OBJCOPYFLAGS_u-boot-app.efi := $(OBJCOPYFLAGS_EFI)
1636 u-boot-app.efi: u-boot FORCE
1637 $(call if_changed,zobjcopy)
1639 u-boot.bin.o: u-boot.bin FORCE
1640 $(call if_changed,efipayload)
1642 u-boot-payload.lds: $(LDSCRIPT_EFI) FORCE
1643 $(call if_changed_dep,cpp_lds)
1645 # Rule to link the EFI payload which contains a stub and a U-Boot binary
1646 quiet_cmd_u-boot_payload ?= LD $@
1647 cmd_u-boot_payload ?= $(LD) $(LDFLAGS_EFI_PAYLOAD) -o $@ \
1648 -T u-boot-payload.lds arch/x86/cpu/call32.o \
1649 lib/efi/efi.o lib/efi/efi_stub.o u-boot.bin.o \
1650 $(addprefix arch/$(ARCH)/lib/,$(EFISTUB))
1652 u-boot-payload: u-boot.bin.o u-boot-payload.lds FORCE
1653 $(call if_changed,u-boot_payload)
1655 OBJCOPYFLAGS_u-boot-payload.efi := $(OBJCOPYFLAGS_EFI)
1656 u-boot-payload.efi: u-boot-payload FORCE
1657 $(call if_changed,zobjcopy)
1659 u-boot-img.bin: spl/u-boot-spl.bin u-boot.img FORCE
1660 $(call if_changed,cat)
1662 #Add a target to create boot binary having SPL binary in PBI format
1663 #concatenated with u-boot binary. It is need by PowerPC SoC having
1664 #internal SRAM <= 512KB.
1665 MKIMAGEFLAGS_u-boot-spl.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
1666 -R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -T pblimage \
1667 -A $(ARCH) -a $(CONFIG_SPL_TEXT_BASE)
1669 spl/u-boot-spl.pbl: spl/u-boot-spl.bin FORCE
1670 $(call if_changed,mkimage)
1673 UBOOT_BINLOAD := u-boot.img
1675 ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1676 UBOOT_BINLOAD := u-boot-with-dtb.bin
1678 UBOOT_BINLOAD := u-boot.bin
1682 OBJCOPYFLAGS_u-boot-with-spl-pbl.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO) \
1685 u-boot-with-spl-pbl.bin: spl/u-boot-spl.pbl $(UBOOT_BINLOAD) FORCE
1686 $(call if_changed,pad_cat)
1688 # PPC4xx needs the SPL at the end of the image, since the reset vector
1689 # is located at 0xfffffffc. So we can't use the "u-boot-img.bin" target
1690 # and need to introduce a new build target with the full blown U-Boot
1691 # at the start padded up to the start of the SPL image. And then concat
1692 # the SPL image to the end.
1694 OBJCOPYFLAGS_u-boot-img-spl-at-end.bin := -I binary -O binary \
1695 --pad-to=$(CONFIG_UBOOT_PAD_TO) --gap-fill=0xff
1696 u-boot-img-spl-at-end.bin: u-boot.img spl/u-boot-spl.bin FORCE
1697 $(call if_changed,pad_cat)
1699 quiet_cmd_u-boot-elf ?= LD $@
1700 cmd_u-boot-elf ?= $(LD) u-boot-elf.o -o $@ \
1701 -T u-boot-elf.lds --defsym=$(CONFIG_PLATFORM_ELFENTRY)=$(CONFIG_SYS_TEXT_BASE) \
1702 -Ttext=$(CONFIG_SYS_TEXT_BASE)
1703 u-boot.elf: u-boot.bin u-boot-elf.lds
1704 $(Q)$(OBJCOPY) -I binary $(PLATFORM_ELFFLAGS) $< u-boot-elf.o
1705 $(call if_changed,u-boot-elf)
1707 u-boot-elf.lds: arch/u-boot-elf.lds prepare FORCE
1708 $(call if_changed_dep,cpp_lds)
1710 # MediaTek's ARM-based u-boot needs a header to contains its load address
1711 # which is parsed by the BootROM.
1712 # If the SPL build is enabled, the header will be added to the spl binary,
1713 # and the spl binary and the u-boot.img will be combined into one file.
1714 # Otherwise the header will be added to the u-boot.bin directly.
1716 ifeq ($(CONFIG_SPL),y)
1717 spl/u-boot-spl-mtk.bin: spl/u-boot-spl
1719 u-boot-mtk.bin: u-boot-with-spl.bin
1720 $(call if_changed,copy)
1722 MKIMAGEFLAGS_u-boot-mtk.bin = -T mtk_image \
1723 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
1724 -n "$(patsubst "%",%,$(CONFIG_MTK_BROM_HEADER_INFO))"
1726 u-boot-mtk.bin: u-boot.bin FORCE
1727 $(call if_changed,mkimage)
1730 quiet_cmd_endian_swap = SWAP $@
1731 cmd_endian_swap = $(srctree)/tools/endian-swap.py $< $@
1733 u-boot-swap.bin: u-boot.bin FORCE
1734 $(call if_changed,endian_swap)
1736 ARCH_POSTLINK := $(wildcard $(srctree)/arch/$(ARCH)/Makefile.postlink)
1738 # Generate linker list symbols references to force compiler to not optimize
1739 # them away when compiling with LTO
1741 u-boot-keep-syms-lto := keep-syms-lto.o
1742 u-boot-keep-syms-lto_c := $(patsubst %.o,%.c,$(u-boot-keep-syms-lto))
1744 quiet_cmd_keep_syms_lto = KSL $@
1745 cmd_keep_syms_lto = \
1746 $(srctree)/scripts/gen_ll_addressable_symbols.sh $(NM) $^ > $@
1748 quiet_cmd_keep_syms_lto_cc = KSLCC $@
1749 cmd_keep_syms_lto_cc = \
1750 $(CC) $(filter-out $(LTO_CFLAGS),$(c_flags)) -c -o $@ $<
1752 $(u-boot-keep-syms-lto_c): $(u-boot-main)
1753 $(call if_changed,keep_syms_lto)
1754 $(u-boot-keep-syms-lto): $(u-boot-keep-syms-lto_c)
1755 $(call if_changed,keep_syms_lto_cc)
1757 u-boot-keep-syms-lto :=
1760 # Rule to link u-boot
1761 # May be overridden by arch/$(ARCH)/config.mk
1763 quiet_cmd_u-boot__ ?= LTO $@
1765 $(CC) -nostdlib -nostartfiles \
1766 $(LTO_FINAL_LDFLAGS) $(c_flags) \
1767 $(KBUILD_LDFLAGS:%=-Wl,%) $(LDFLAGS_u-boot:%=-Wl,%) -o $@ \
1768 -T u-boot.lds $(u-boot-init) \
1769 -Wl,--whole-archive \
1771 $(u-boot-keep-syms-lto) \
1773 -Wl,--no-whole-archive \
1774 -Wl,-Map,u-boot.map; \
1775 $(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
1777 # Note: Linking efi-x86_app64 causes a segfault in the linker at present
1778 # when using x86_64-linux-gnu-ld.bfd
1779 # For now, disable --whole-archive which makes things link, although not
1781 quiet_cmd_u-boot__ ?= LD $@
1782 cmd_u-boot__ ?= $(LD) $(KBUILD_LDFLAGS) $(LDFLAGS_u-boot) -o $@ \
1783 -T u-boot.lds $(u-boot-init) \
1786 --no-whole-archive \
1787 $(PLATFORM_LIBS) -Map u-boot.map; \
1788 $(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
1791 quiet_cmd_smap = GEN common/system_map.o
1793 smap=`$(call SYSTEM_MAP,u-boot) | \
1794 awk '$$2 ~ /[tTwW]/ {printf $$1 $$3 "\\\\000"}'` ; \
1795 $(CC) $(c_flags) -DSYSTEM_MAP="\"$${smap}\"" \
1796 -c $(srctree)/common/system_map.c -o common/system_map.o
1798 u-boot: $(u-boot-init) $(u-boot-main) $(u-boot-keep-syms-lto) u-boot.lds FORCE
1799 +$(call if_changed,u-boot__)
1800 ifeq ($(CONFIG_KALLSYMS),y)
1802 $(call cmd,u-boot__) common/system_map.o
1805 ifeq ($(CONFIG_RISCV),y)
1806 @tools/prelink-riscv $@ 0
1809 quiet_cmd_sym ?= SYM $@
1810 cmd_sym ?= $(OBJDUMP) -t $< > $@
1811 u-boot.sym: u-boot FORCE
1812 $(call if_changed,sym)
1814 # Environment processing
1815 # ---------------------------------------------------------------------------
1817 # Directory where we expect the .env file, if it exists
1818 ENV_DIR := $(srctree)/board/$(BOARDDIR)
1820 # Basename of .env file, stripping quotes
1821 ENV_SOURCE_FILE := $(CONFIG_ENV_SOURCE_FILE:"%"=%)
1823 # Filename of .env file
1824 ENV_FILE_CFG := $(ENV_DIR)/$(ENV_SOURCE_FILE).env
1826 # Default filename, if CONFIG_ENV_SOURCE_FILE is empty
1827 ENV_FILE_BOARD := $(ENV_DIR)/$(CONFIG_SYS_BOARD:"%"=%).env
1829 # Select between the CONFIG_ENV_SOURCE_FILE and the default one
1830 ENV_FILE := $(if $(ENV_SOURCE_FILE),$(ENV_FILE_CFG),$(wildcard $(ENV_FILE_BOARD)))
1832 # Run the environment text file through the preprocessor, but only if it is
1833 # non-empty, to save time and possible build errors if something is wonky with
1835 quiet_cmd_gen_envp = ENVP $@
1837 if [ -s "$(ENV_FILE)" ]; then \
1838 $(CPP) -P $(CFLAGS) -x assembler-with-cpp -D__ASSEMBLY__ \
1839 -D__UBOOT_CONFIG__ \
1840 -I . -I include -I $(srctree)/include \
1841 -include linux/kconfig.h -include include/config.h \
1842 -I$(srctree)/arch/$(ARCH)/include \
1847 include/generated/env.in: include/generated/env.txt FORCE
1848 $(call cmd,gen_envp)
1850 # Regenerate the environment if it changes
1851 # We use 'wildcard' since the file is not required to exist (at present), in
1852 # which case we don't want this dependency, but instead should create an empty
1854 # This rule is useful since it shows the source file for the environment
1855 quiet_cmd_envc = ENVC $@
1857 if [ -f "$<" ]; then \
1859 elif [ -n "$(ENV_SOURCE_FILE)" ]; then \
1860 echo "Missing file $(ENV_FILE_CFG)"; \
1865 include/generated/env.txt: $(wildcard $(ENV_FILE)) FORCE
1868 # Write out the resulting environment, converted to a C string
1869 quiet_cmd_gen_envt = ENVT $@
1871 awk -f $(srctree)/scripts/env2string.awk $< >$@
1872 $(env_h): include/generated/env.in
1873 $(call cmd,gen_envt)
1875 # ---------------------------------------------------------------------------
1877 # The actual objects are generated when descending,
1878 # make sure no implicit rule kicks in
1879 $(sort $(u-boot-init) $(u-boot-main)): $(u-boot-dirs) ;
1881 # Handle descending into subdirectories listed in $(u-boot-dirs)
1882 # Preset locale variables to speed up the build process. Limit locale
1883 # tweaks to this spot to avoid wrong language settings when running
1884 # make menuconfig etc.
1885 # Error messages still appears in the original language
1887 PHONY += $(u-boot-dirs)
1888 $(u-boot-dirs): prepare scripts
1889 $(Q)$(MAKE) $(build)=$@
1892 # The "tools" are needed early
1893 $(filter-out tools, $(u-boot-dirs)): tools
1894 # The "examples" conditionally depend on U-Boot (say, when USE_PRIVATE_LIBGCC
1895 # is "yes"), so compile examples after U-Boot is compiled.
1896 examples: $(filter-out examples, $(u-boot-dirs))
1898 define filechk_uboot.release
1899 echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
1902 # Store (new) UBOOTRELEASE string in include/config/uboot.release
1903 include/config/uboot.release: include/config/auto.conf FORCE
1904 $(call filechk,uboot.release)
1907 # Things we need to do before we recursively start building the kernel
1908 # or the modules are listed in "prepare".
1909 # A multi level approach is used. prepareN is processed before prepareN-1.
1910 # archprepare is used in arch Makefiles and when processed asm symlink,
1911 # version.h and scripts_basic is processed / created.
1913 # Listed in dependency order
1914 PHONY += prepare archprepare prepare0 prepare1 prepare2 prepare3
1916 # prepare3 is used to check if we are building in a separate output directory,
1918 # 1) Check that make has not been executed in the kernel src $(srctree)
1919 prepare3: include/config/uboot.release
1920 ifneq ($(KBUILD_SRC),)
1921 @$(kecho) ' Using $(srctree) as source for U-Boot'
1922 $(Q)if [ -f $(srctree)/.config -o -d $(srctree)/include/config ]; then \
1923 echo >&2 " $(srctree) is not clean, please run 'make mrproper'"; \
1924 echo >&2 " in the '$(srctree)' directory.";\
1929 # prepare2 creates a makefile if using a separate output directory
1930 prepare2: prepare3 outputmakefile cfg
1932 prepare1: prepare2 $(version_h) $(timestamp_h) $(dt_h) $(env_h) \
1933 include/config/auto.conf
1934 ifeq ($(wildcard $(LDSCRIPT)),)
1935 @echo >&2 " Could not find linker script."
1939 ifeq ($(CONFIG_USE_DEFAULT_ENV_FILE),y)
1940 prepare1: $(defaultenv_h)
1942 envtools: $(defaultenv_h)
1945 archprepare: prepare1 scripts_basic
1947 prepare0: archprepare FORCE
1948 $(Q)$(MAKE) $(build)=.
1950 # All the preparing..
1953 # Generate some files
1954 # ---------------------------------------------------------------------------
1956 # Use sed to remove leading zeros from PATCHLEVEL to avoid using octal numbers
1957 define filechk_version.h
1958 (echo \#define PLAIN_VERSION \"$(UBOOTRELEASE)\"; \
1959 echo \#define U_BOOT_VERSION \"U-Boot \" PLAIN_VERSION; \
1960 echo \#define U_BOOT_VERSION_NUM $(VERSION); \
1961 echo \#define U_BOOT_VERSION_NUM_PATCH $$(echo $(PATCHLEVEL) | \
1962 sed -e "s/^0*//"); \
1963 echo \#define CC_VERSION_STRING \"$$(LC_ALL=C $(CC) --version | head -n 1)\"; \
1964 echo \#define LD_VERSION_STRING \"$$(LC_ALL=C $(LD) --version | head -n 1)\"; )
1967 # The SOURCE_DATE_EPOCH mechanism requires a date that behaves like GNU date.
1968 # The BSD date on the other hand behaves different and would produce errors
1969 # with the misused '-d' switch. Respect that and search a working date with
1970 # well known pre- and suffixes for the GNU variant of date.
1971 define filechk_timestamp.h
1972 (if test -n "$${SOURCE_DATE_EPOCH}"; then \
1973 SOURCE_DATE="@$${SOURCE_DATE_EPOCH}"; \
1975 for date in gdate date.gnu date; do \
1976 $${date} -u -d "$${SOURCE_DATE}" >/dev/null 2>&1 && DATE="$${date}"; \
1978 if test -n "$${DATE}"; then \
1979 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_DATE "%b %d %C%y"'; \
1980 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TIME "%T"'; \
1981 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TZ "%z"'; \
1982 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_EPOCH %s'; \
1987 LC_ALL=C date +'#define U_BOOT_DATE "%b %d %C%y"'; \
1988 LC_ALL=C date +'#define U_BOOT_TIME "%T"'; \
1989 LC_ALL=C date +'#define U_BOOT_TZ "%z"'; \
1990 LC_ALL=C date +'#define U_BOOT_EPOCH %s'; \
1994 define filechk_defaultenv.h
1995 ( { grep -v '^#' | grep -v '^$$' || true ; echo '' ; } | \
1997 sed -e 's/\\\x0\s*//g' | \
2002 (if test -n "$${DEVICE_TREE}"; then \
2003 echo \#define DEVICE_TREE \"$(DEVICE_TREE)\"; \
2005 echo \#define DEVICE_TREE CONFIG_DEFAULT_DEVICE_TREE; \
2009 $(version_h): include/config/uboot.release FORCE
2010 $(call filechk,version.h)
2012 $(timestamp_h): $(srctree)/Makefile FORCE
2013 $(call filechk,timestamp.h)
2015 $(dt_h): $(srctree)/Makefile FORCE
2016 $(call filechk,dt.h)
2018 $(defaultenv_h): $(CONFIG_DEFAULT_ENV_FILE:"%"=%) FORCE
2019 $(call filechk,defaultenv.h)
2021 # ---------------------------------------------------------------------------
2024 ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/boot/dts/),)
2025 dtstree := arch/$(SRCARCH)/boot/dts
2030 %.dtb: prepare3 scripts_dtc
2031 $(Q)$(MAKE) $(build)=$(dtstree) $(dtstree)/$@
2033 PHONY += dtbs dtbs_install
2034 dtbs: prepare3 scripts_dtc
2035 $(Q)$(MAKE) $(build)=$(dtstree)
2038 $(Q)$(MAKE) $(dtbinst)=$(dtstree)
2040 ifdef CONFIG_OF_EARLY_FLATTREE
2046 # Check dtc and pylibfdt, if DTC is provided, else build them
2047 PHONY += scripts_dtc
2048 scripts_dtc: scripts_basic
2049 $(Q)if test "$(DTC)" = "$(DTC_INTREE)"; then \
2050 $(MAKE) $(build)=scripts/dtc; \
2052 if ! $(DTC) -v >/dev/null; then \
2053 echo '*** Failed to check dtc version: $(DTC)'; \
2056 if test "$(call dtc-version)" -lt $(DTC_MIN_VERSION); then \
2057 echo '*** Your dtc is too old, please upgrade to dtc $(DTC_MIN_VERSION) or newer'; \
2060 if [ -n "$(CONFIG_PYLIBFDT)" ]; then \
2061 if ! echo "import libfdt" | $(PYTHON3) 2>/dev/null; then \
2062 echo '*** pylibfdt does not seem to be available with $(PYTHON3)'; \
2070 # ---------------------------------------------------------------------------
2071 quiet_cmd_cpp_lds = LDS $@
2072 cmd_cpp_lds = $(CPP) -Wp,-MD,$(depfile) $(cpp_flags) $(LDPPFLAGS) \
2073 -D__ASSEMBLY__ -x assembler-with-cpp -std=c99 -P -o $@ $<
2075 u-boot.lds: $(LDSCRIPT) prepare FORCE
2076 $(call if_changed_dep,cpp_lds)
2078 spl/u-boot-spl.bin: spl/u-boot-spl
2082 spl/u-boot-spl-dtb.bin: spl/u-boot-spl
2085 spl/u-boot-spl-dtb.hex: spl/u-boot-spl
2088 spl/u-boot-spl: tools prepare \
2089 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SPL_OF_PLATDATA),dts/dt.dtb) \
2090 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_TPL_OF_PLATDATA),dts/dt.dtb)
2091 $(Q)$(MAKE) obj=spl -f $(srctree)/scripts/Makefile.spl all
2093 spl/sunxi-spl.bin: spl/u-boot-spl
2096 spl/sunxi-spl-with-ecc.bin: spl/sunxi-spl.bin
2099 spl/u-boot-spl.sfp: spl/u-boot-spl
2102 spl/boot.bin: spl/u-boot-spl
2105 tpl/u-boot-tpl.bin: tools prepare \
2106 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SPL_OF_PLATDATA),dts/dt.dtb)
2107 $(Q)$(MAKE) obj=tpl -f $(srctree)/scripts/Makefile.spl all
2110 TAG_SUBDIRS := $(patsubst %,$(srctree)/%,$(u-boot-dirs) include)
2116 ctags -w -o ctags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
2117 -name '*.[chS]' -print`
2121 etags -a -o etags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
2122 -name '*.[chS]' -print`
2124 $(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) -name '*.[chS]' -print > \
2126 @find $(TAG_SUBDIRS) -name '*.[chS]' -type l -print | \
2127 grep -xvf - cscope.files > cscope.files.no-symlinks; \
2128 mv cscope.files.no-symlinks cscope.files
2133 grep -v '\(compiled\)\|\(\.o$$\)\|\( [aUw] \)\|\(\.\.ng$$\)\|\(LASH[RL]DI\)' | \
2136 @$(call SYSTEM_MAP,$<) > $@
2138 #########################################################################
2140 # ARM relocations should all be R_ARM_RELATIVE (32-bit) or
2141 # R_AARCH64_RELATIVE (64-bit).
2142 checkarmreloc: u-boot
2143 @RELOC="`$(CROSS_COMPILE)readelf -r -W $< | cut -d ' ' -f 4 | \
2144 grep R_A | sort -u`"; \
2145 if test "$$RELOC" != "R_ARM_RELATIVE" -a \
2146 "$$RELOC" != "R_AARCH64_RELATIVE"; then \
2147 echo "$< contains unexpected relocations: $$RELOC"; \
2151 tools/version.h: include/version.h
2152 $(Q)mkdir -p $(dir $@)
2153 $(call if_changed,copy)
2155 envtools: scripts_basic $(version_h) $(timestamp_h) tools/version.h
2156 $(Q)$(MAKE) $(build)=tools/env
2158 tools-only: export TOOLS_ONLY=y
2159 tools-only: scripts_basic $(version_h) $(timestamp_h) tools/version.h
2160 $(Q)$(MAKE) $(build)=tools
2162 tools-all: export HOST_TOOLS_ALL=y
2163 tools-all: envtools tools ;
2165 cross_tools: export CROSS_BUILD_TOOLS=y
2166 cross_tools: tools ;
2170 git log --no-merges U-Boot-1_1_5.. | \
2171 unexpand -a | sed -e 's/\s\s*$$//' > $@
2173 #########################################################################
2176 # Cleaning is done on three levels.
2177 # make clean Delete most generated files
2178 # Leave enough to build external modules
2179 # make mrproper Delete the current configuration, and all generated files
2180 # make distclean Remove editor backup files, patch leftover files and the like
2182 # Directories & files removed with 'make clean'
2183 CLEAN_DIRS += $(MODVERDIR) \
2184 $(foreach d, spl tpl, $(patsubst %,$d/%, \
2185 $(filter-out include, $(shell ls -1 $d 2>/dev/null))))
2187 CLEAN_FILES += include/bmp_logo.h include/bmp_logo_data.h tools/version.h \
2188 u-boot* MLO* SPL System.map fit-dtb.blob* \
2189 u-boot-ivt.img.log u-boot-dtb.imx.log SPL.log u-boot.imx.log \
2190 lpc32xx-* bl31.c bl31.elf bl31_*.bin image.map tispl.bin* \
2191 idbloader.img flash.bin flash.log defconfig keep-syms-lto.c \
2192 mkimage-out.spl.mkimage mkimage.spl.mkimage imx-boot.map \
2193 itb.fit.fit itb.fit.itb itb.map spl.map
2195 # Directories & files removed with 'make mrproper'
2196 MRPROPER_DIRS += include/config include/generated spl tpl \
2197 .tmp_objdiff doc/output include/asm
2199 # Remove include/asm symlink created by U-Boot before v2014.01
2200 MRPROPER_FILES += .config .config.old include/autoconf.mk* include/config.h \
2201 ctags etags tags TAGS cscope* GPATH GTAGS GRTAGS GSYMS \
2202 drivers/video/fonts/*.S include/asm
2204 # clean - Delete most, but leave enough to build external modules
2206 clean: rm-dirs := $(CLEAN_DIRS)
2207 clean: rm-files := $(CLEAN_FILES)
2209 clean-dirs := $(foreach f,$(u-boot-alldirs),$(if $(wildcard $(srctree)/$f/Makefile),$f))
2211 clean-dirs := $(addprefix _clean_, $(clean-dirs))
2213 PHONY += $(clean-dirs) clean archclean
2215 $(Q)$(MAKE) $(clean)=$(patsubst _clean_%,%,$@)
2217 clean: $(clean-dirs)
2220 @find $(if $(KBUILD_EXTMOD), $(KBUILD_EXTMOD), .) $(RCS_FIND_IGNORE) \
2221 \( -name '*.[oas]' -o -name '*.ko' -o -name '.*.cmd' \
2222 -o -name '*.ko.*' -o -name '*.su' -o -name '*.pyc' \
2223 -o -name '.*.d' -o -name '.*.tmp' -o -name '*.mod.c' \
2224 -o -name '*.lex.c' -o -name '*.tab.[ch]' \
2225 -o -name '*.asn1.[ch]' \
2226 -o -name '*.symtypes' -o -name 'modules.order' \
2227 -o -name modules.builtin -o -name '.tmp_*.o.*' \
2228 -o -name 'dsdt.aml' -o -name 'dsdt.asl.tmp' -o -name 'dsdt.c' \
2229 -o -name '*.efi' -o -name '*.gcno' -o -name '*.so' \) \
2230 -type f -print | xargs rm -f
2232 # mrproper - Delete all generated files, including .config
2234 mrproper: rm-dirs := $(wildcard $(MRPROPER_DIRS))
2235 mrproper: rm-files := $(wildcard $(MRPROPER_FILES))
2236 mrproper-dirs := $(addprefix _mrproper_,scripts)
2238 PHONY += $(mrproper-dirs) mrproper archmrproper
2240 $(Q)$(MAKE) $(clean)=$(patsubst _mrproper_%,%,$@)
2242 mrproper: clean $(mrproper-dirs)
2245 @rm -f arch/*/include/asm/arch
2252 @find $(srctree) $(RCS_FIND_IGNORE) \
2253 \( -name '*.orig' -o -name '*.rej' -o -name '*~' \
2254 -o -name '*.bak' -o -name '#*#' -o -name '.*.orig' \
2255 -o -name '.*.rej' -o -name '*%' -o -name 'core' \
2256 -o -name '*.pyc' \) \
2257 -type f -print | xargs rm -f
2258 @rm -f boards.cfg CHANGELOG
2260 # See doc/develop/python_cq.rst
2262 PYLINT_BASE := scripts/pylint.base
2263 PYLINT_CUR := pylint.cur
2264 PYLINT_DIFF := pylint.diff
2266 $(Q)echo "Running pylint on all files (summary in $(PYLINT_CUR); output in pylint.out/)"
2267 $(Q)mkdir -p pylint.out
2268 $(Q)rm -f pylint.out/out*
2269 $(Q)find tools test -name "*.py" \
2270 | xargs -n1 -P$(shell nproc 2>/dev/null || echo 1) \
2271 sh -c 'pylint --reports=y --exit-zero -f parseable --ignore-imports=yes $$@ > pylint.out/$$(echo $$@ | tr / _ | sed s/.py//)' _
2272 $(Q)rm -f $(PYLINT_CUR)
2273 $(Q)( cd pylint.out; for f in *; do \
2274 sed -ne "s/Your code has been rated at \([-0-9.]*\).*/$$f \1/p" $$f; \
2275 done ) | sort > $(PYLINT_CUR)
2276 $(Q)base=$$(mktemp) cur=$$(mktemp); cut -d' ' -f1 $(PYLINT_BASE) >$$base; \
2277 cut -d' ' -f1 $(PYLINT_CUR) >$$cur; \
2278 comm -3 $$base $$cur > $(PYLINT_DIFF); \
2279 if [ -s $(PYLINT_DIFF) ]; then \
2280 echo "Files have been added/removed. Try:\n\tcp $(PYLINT_CUR) $(PYLINT_BASE)"; \
2282 echo "Added files:"; \
2283 comm -13 $$base $$cur; \
2285 echo "Removed files:"; \
2286 comm -23 $$base $$cur; \
2289 rm $$base $$cur $(PYLINT_DIFF); \
2291 $(Q)bad=false; while read base_file base_val <&3 && read cur_file cur_val <&4; do \
2292 if awk "BEGIN {exit !($$cur_val < $$base_val)}"; then \
2293 echo "$$base_file: Score was $$base_val, now $$cur_val"; \
2295 done 3<$(PYLINT_BASE) 4<$(PYLINT_CUR); \
2297 echo "Some files have regressed, please fix"; \
2300 echo "No pylint regressions"; \
2304 F=`basename $(srctree)` ; cd .. ; \
2305 gtar --force-local -zcvf `LC_ALL=C date "+$$F-%Y-%m-%d-%T.tar.gz"` $$F
2308 @echo 'Cleaning targets:'
2309 @echo ' clean - Remove most generated files but keep the config'
2310 @echo ' mrproper - Remove all generated files + config + various backup files'
2311 @echo ' distclean - mrproper + remove editor backup and patch files'
2313 @echo 'Configuration targets:'
2314 @$(MAKE) -f $(srctree)/scripts/kconfig/Makefile help
2316 @echo 'Test targets:'
2318 @echo ' check - Run all automated tests that use sandbox'
2319 @echo ' qcheck - Run quick automated tests that use sandbox'
2320 @echo ' tcheck - Run quick automated tests on tools'
2321 @echo ' pylint - Run pylint on all Python files'
2323 @echo 'Other generic targets:'
2324 @echo ' all - Build all necessary images depending on configuration'
2325 @echo ' tests - Build U-Boot for sandbox and run tests'
2326 @echo '* u-boot - Build the bare u-boot'
2327 @echo ' dir/ - Build all files in dir and below'
2328 @echo ' dir/file.[oisS] - Build specified target only'
2329 @echo ' dir/file.lst - Build specified mixed source/assembly target only'
2330 @echo ' (requires a recent binutils and recent build (System.map))'
2331 @echo ' tags/ctags - Generate ctags file for editors'
2332 @echo ' etags - Generate etags file for editors'
2333 @echo ' cscope - Generate cscope index'
2334 @echo ' ubootrelease - Output the release version string (use with make -s)'
2335 @echo ' ubootversion - Output the version stored in Makefile (use with make -s)'
2336 @echo " cfg - Don't build, just create the .cfg files"
2337 @echo " envtools - Build only the target-side environment tools"
2339 @echo 'Static analysers'
2340 @echo ' checkstack - Generate a list of stack hogs'
2341 @echo ' coccicheck - Execute static code analysis with Coccinelle'
2343 @echo 'Documentation targets:'
2344 @$(MAKE) -f $(srctree)/doc/Makefile dochelp
2346 @echo ' make V=0|1 [targets] 0 => quiet build (default), 1 => verbose build'
2347 @echo ' make V=2 [targets] 2 => give reason for rebuild of target'
2348 @echo ' make O=dir [targets] Locate all output files in "dir", including .config'
2349 @echo ' make C=1 [targets] Check all c source with $$CHECK (sparse by default)'
2350 @echo ' make C=2 [targets] Force check of all c source with $$CHECK'
2351 @echo ' make RECORDMCOUNT_WARN=1 [targets] Warn about ignored mcount sections'
2352 @echo ' make W=n [targets] Enable extra gcc checks, n=1,2,3 where'
2353 @echo ' 1: warnings which may be relevant and do not occur too often'
2354 @echo ' 2: warnings which occur quite often but may still be relevant'
2355 @echo ' 3: more obscure warnings, can most likely be ignored'
2356 @echo ' Multiple levels can be combined with W=12 or W=123'
2358 @echo 'Execute "make" or "make all" to build all targets marked with [*] '
2359 @echo 'For further info see the ./README file'
2365 $(srctree)/test/run quick
2368 $(srctree)/test/run tools
2370 # Documentation targets
2371 # ---------------------------------------------------------------------------
2372 DOC_TARGETS := xmldocs latexdocs pdfdocs htmldocs epubdocs cleandocs \
2373 linkcheckdocs dochelp refcheckdocs
2374 PHONY += $(DOC_TARGETS)
2375 $(DOC_TARGETS): scripts_basic FORCE
2376 $(Q)$(MAKE) $(build)=doc $@
2378 PHONY += checkstack ubootrelease ubootversion
2381 $(OBJDUMP) -d u-boot $$(find . -name u-boot-spl) | \
2382 $(PERL) $(src)/scripts/checkstack.pl $(ARCH)
2385 @echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
2388 @echo $(UBOOTVERSION)
2391 # ---------------------------------------------------------------------------
2392 # Single targets are compatible with:
2393 # - build with mixed source and output
2394 # - build with separate output dir 'make O=...'
2395 # - external modules
2397 # target-dir => where to store outputfile
2398 # build-dir => directory in kernel source tree to use
2400 ifeq ($(KBUILD_EXTMOD),)
2401 build-dir = $(patsubst %/,%,$(dir $@))
2402 target-dir = $(dir $@)
2404 zap-slash=$(filter-out .,$(patsubst %/,%,$(dir $@)))
2405 build-dir = $(KBUILD_EXTMOD)$(if $(zap-slash),/$(zap-slash))
2406 target-dir = $(if $(KBUILD_EXTMOD),$(dir $<),$(dir $@))
2409 %.s: %.c prepare scripts FORCE
2410 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2411 %.i: %.c prepare scripts FORCE
2412 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2413 %.o: %.c prepare scripts FORCE
2414 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2415 %.lst: %.c prepare scripts FORCE
2416 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2417 %.s: %.S prepare scripts FORCE
2418 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2419 %.o: %.S prepare scripts FORCE
2420 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2421 %.symtypes: %.c prepare scripts FORCE
2422 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2425 /: prepare scripts FORCE
2427 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2428 $(build)=$(build-dir)
2429 %/: prepare scripts FORCE
2431 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2432 $(build)=$(build-dir)
2433 %.ko: prepare scripts FORCE
2435 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2436 $(build)=$(build-dir) $(@:.ko=.o)
2437 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.modpost
2439 quiet_cmd_genenv = GENENV $@
2440 cmd_genenv = $(OBJCOPY) --dump-section .rodata.default_environment=$@ env/common.o; \
2441 sed --in-place -e 's/\x00/\x0A/g' $@
2443 u-boot-initial-env: u-boot.bin
2444 $(call if_changed,genenv)
2446 # Consistency checks
2447 # ---------------------------------------------------------------------------
2452 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/$@
2454 # FIXME Should go into a make.lib or something
2455 # ===========================================================================
2457 quiet_cmd_rmdirs = $(if $(wildcard $(rm-dirs)),CLEAN $(wildcard $(rm-dirs)))
2458 cmd_rmdirs = rm -rf $(rm-dirs)
2460 quiet_cmd_rmfiles = $(if $(wildcard $(rm-files)),CLEAN $(wildcard $(rm-files)))
2461 cmd_rmfiles = rm -f $(rm-files)
2463 # read all saved command lines
2465 cmd_files := $(wildcard .*.cmd)
2467 ifneq ($(cmd_files),)
2468 $(cmd_files): ; # Do not try to update included dependency files
2469 include $(cmd_files)
2472 endif #ifeq ($(config-targets),1)
2473 endif #ifeq ($(mixed-targets),1)
2474 endif # skip-makefile
2479 # Declare the contents of the PHONY variable as phony. We keep that
2480 # information in a variable so we can use it in if_changed and friends.